#include <stdio.h>
#include <string.h>
#include <stdlib.h>

void Calculate_Easter(int yr, char *mn, int *date);

void main()
    {
    char s[80];
    char month[10];
    int day;
    int year;
	for(;;)
	{
		printf("\nEnter year from 1900 to 2099 (CR to end): ");
		gets(s);
		if (strlen(s) == 0) break;
		sscanf(s, "%d", &year);
		if ((year >= 1900) && (year <= 2099))
			{
			Calculate_Easter(year, month, &day);
			printf("\nIn the year %d Easter falls on %s %d\n", year, month, day);
			}
	}
	exit(0);
    }

/******\
*
* Calculate_Easter
*
* Algorithm from Scientific American February 1981 Mathematical Games column
*
* valid for years 1900 thru 2099
*
\******/

void Calculate_Easter(int yr, char *mn, int *date)
    {
    int a, b, m, n, q, w;

    n = yr - 1900;
    a = n % 19;
    b = (7*a + 1) / 19;
    m = (11*a + 4 - b) % 29;
    q = n / 4;
    w = (n + q + 31 - m) % 7;

    *date = (25 - m - w);
    if (*date >= 1)
    	{
    	strcpy(mn, "April");
    	}
    else
    	{
    	strcpy(mn, "March");
    	*date = 31 + *date;
    	}
    }
